libuc2=$$(libuc2)
QMAKE_CC=arm-none-eabi-gcc
message(C compiler forced to: $$QMAKE_CC)
QMAKE_CXX=arm-none-eabi-g++
message(C++ compiler forced to: $$QMAKE_CXX)
QMAKE_AR=arm-none-eabi-ar rcs
message(Archiver forced to: $$QMAKE_AR)
QMAKE_LINK=arm-none-eabi-gcc
message(Linker forced to: $$QMAKE_LINK)
QMAKE_LINK_SHLIB=arm-none-eabi-g++
QMAKE_OBJCOPY= arm-none-eabi-objcopy
QMAKE_STRIP=arm-none-eabi-strip
QMAKE_GDB=arm-none-eabi-gdb
INCLUDEPATH =
ARCH=stm32f4-arm-none-eabi-gcc

QMAKE_CFLAGS_DEBUG= -g
QMAKE_CFLAGS_RELEASE=""
QMAKE_CXXFLAGS_DEBUG= -g
QMAKE_CXXFLAGS_RELEASE=""
QMAKE_LFLAGS_RELEASE=""
QMAKE_LFLAGS_DEBUG= -g
QMAKE_CXXFLAGS_DEPS	=
QMAKE_CXXFLAGS_WARN_ON	= -Wall
QMAKE_CXXFLAGS_WARN_OFF	= -w
QMAKE_CXXFLAGS_RELEASE	=
QMAKE_CXXFLAGS_DEBUG	=
QMAKE_CXXFLAGS_YACC	=
QMAKE_CXXFLAGS_THREAD	=
QMAKE_CXXFLAGS_RTTI_ON	=
QMAKE_CXXFLAGS_RTTI_OFF	=
QMAKE_CXXFLAGS_EXCEPTIONS_ON =
QMAKE_CXXFLAGS_EXCEPTIONS_OFF =
QMAKE_CFLAGS_WARN_ON	= -Wall
QMAKE_CFLAGS_WARN_OFF	= -w
QMAKE_CFLAGS_RELEASE	=
QMAKE_CFLAGS_YACC	=
QMAKE_LFLAGS_EXCEPTIONS_ON =
QMAKE_LFLAGS_EXCEPTIONS_OFF =
QMAKE_LFLAGS_RELEASE	=
QMAKE_LFLAGS_CONSOLE	=
QMAKE_LFLAGS_WINDOWS	=
QMAKE_LFLAGS_DLL        =
QMAKE_INCDIR_QT         =
QMAKE_INCDIR            =
QMAKE_CFLAGS_SHLIB	  =
QMAKE_CFLAGS_STATIC_LIB	  =
QMAKE_CXXFLAGS_SHLIB	  =
QMAKE_CXXFLAGS_STATIC_LIB =

contains( TEMPLATE, app ) {
    OBJECTS_DIR=obj
    DESTDIR=bin
    unix:QMAKE_POST_LINK += arm-none-eabi-objcopy -O ihex "$(TARGET)" $$DESTDIR/"$(QMAKE_TARGET).hex" && arm-none-eabi-objcopy -O binary "$(TARGET)" $$DESTDIR/"$(QMAKE_TARGET).bin"
    win32:QMAKE_POST_LINK += arm-none-eabi-objcopy -O ihex "$(DESTDIR_TARGET)" $$DESTDIR/"$(QMAKE_TARGET).hex" && arm-none-eabi-objcopy -O binary "$(DESTDIR_TARGET)" $$DESTDIR/"$(QMAKE_TARGET).bin"


}

contains( TEMPLATE, app ) {
    #include($$libuc2/bsp/cfg/$$BSP/bsp.pri)
    LIBS += -L$$libuc2/bsp/bin/$$BSP
    LIBS += -lbsp
}

include($$libuc2/rules/common/librules.pri)

contains( TEMPLATE, lib ) {
    OBJECTS_DIR=obj
    contains( CONFIG, bsp ){
        TARGET = bsp
        DESTDIR=$$libuc2/bsp/bin/$$BSP
        INCLUDEPATH += $$libuc2/bsp/includes/$$BSP
        message(Writting a Makefile for a bsp)
    }else{
        message(Writting a Makefile for a library)
        DESTDIR=$$LIBUC_BIN_LIBS_DIR
    }

}


QMAKE_CFLAGS_RELEASE+= -O3 -mlittle-endian -mthumb -mcpu=cortex-m4 -mfloat-abi=hard -mfpu=fpv4-sp-d16 -std=c99
QMAKE_CFLAGS_DEBUG+= -O3 -mlittle-endian -mthumb -mcpu=cortex-m4 -mfloat-abi=hard -mfpu=fpv4-sp-d16 -std=c99
QMAKE_CXXFLAGS_RELEASE+= -O3 -mlittle-endian -mthumb -mcpu=cortex-m4 -mfloat-abi=hard -mfpu=fpv4-sp-d16 -std=c99
QMAKE_CXXFLAGS_DEBUG+= -O3 -mlittle-endian -mthumb -mcpu=cortex-m4 -mfloat-abi=hard -mfpu=fpv4-sp-d16 -std=c99

contains( TEMPLATE, app ) {
    QMAKE_LFLAGS_DEBUG+= -O3 -mlittle-endian -mthumb -mcpu=cortex-m4 -mfloat-abi=hard -mfpu=fpv4-sp-d16 -std=c99 -T $$libuc2/lib/src/stm32f4/CPU/$$CPU/stm32_flash.ld
    QMAKE_LFLAGS_RELEASE+= -O3 -mlittle-endian -mthumb -mcpu=cortex-m4 -mfloat-abi=hard -mfpu=fpv4-sp-d16 -std=c99 -T $$libuc2/lib/src/stm32f4/CPU/$$CPU/stm32_flash.ld
}

contains( TEMPLATE, lib ) {
    CONFIG+=staticlib
}

INCLUDEPATH+=$$libuc2/lib/includes \
                $$libuc2/lib/includes/$$ARCH

contains( TEMPLATE, app ) {
    INCLUDEPATH+=$$libuc2/bsp/includes/$$BSP
    SOURCES +=$$libuc2/lib/src/stm32f4/CPU/$$CPU/fs.c
    SOURCES +=$$libuc2/rules/$$ARCH/syscalls.c

    SOURCES +=$$libuc2/lib/src/stm32f4/CPU/$$CPU/startup.s
    SOURCES +=$$libuc2/lib/src/stm32f4/CPU/$$CPU/cpuinit.c

    #SOURCES +=$$libuc2/lib/src/stm32f4/CPU/$$CPU/startup_stm32f4xx.s
    #SOURCES +=$$libuc2/lib/src/stm32f4/CPU/system_stm32f4xx.c

    OTHER_FILES += $$libuc2/lib/src/stm32f4/CPU/$$CPU/stm32_flash.ld

    stflash.target = stflash
    stflash.commands = cd $$DESTDIR && sudo st-flash write $(QMAKE_TARGET).bin 0x08000000
    QMAKE_EXTRA_TARGETS += stflash
}

















